#include "Queue.hh"
#include "Guard.hh"

Queue::Queue(unsigned int size)
: capacity_(size)
{}

void Queue::put(WorkItem work_item) {
	Guard guard(queue_lock_);

	while(queue_.size()>=capacity_) {
		full_.wait(queue_lock_);
	}
	queue_.push_back(work_item);
	if(queue_.size()==1) {
		empty_.notify_one();
	}
}

WorkItem Queue::get() {
	Guard guard(queue_lock_);

	while(queue_.size()==0) {
		empty_.wait(queue_lock_);
	}
	WorkItem work=queue_.front();
	queue_.pop_front();
	if(queue_.size()==(capacity_-1)) {
		full_.notify_one();
	}

	return work;
}

bool Queue::is_full() {
	Guard guard(queue_lock_);
	return queue_.size()==capacity_;
}

bool Queue::is_empty() {
	Guard guard(queue_lock_);
	return queue_.empty();
}

unsigned Queue::size() {
	Guard guard(queue_lock_);
	return queue_.size();
}


