#ifndef QUEUE_HH__
#define QUEUE_HH__

#include <deque>
#include "WorkItem.hh"

#include "Mutex.hh"
#include "Condition.hh"

class Queue {
	const unsigned int capacity_;

	std::deque<WorkItem> queue_;
	Mutex queue_lock_;

	Condition full_;
	Condition empty_;
public:
	Queue(unsigned int capacity);

	void put(WorkItem work);
	WorkItem get();

	bool is_full();
	bool is_empty();

	unsigned int size();
};

#endif
